
<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="客户编号" prop="number">
        <el-input v-model="queryParams.number" placeholder="请输入客户编号" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="客户名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入客户名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="客户等级" prop="level">
        <el-select v-model="queryParams.level" placeholder="请选择客户等级" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_LEVEL)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item label="客户来源" prop="source">
        <el-select v-model="queryParams.source" placeholder="请选择客户来源" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_SOURCE)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item label="客户经理" prop="customerService">
        <el-select v-model="queryParams.customerService" placeholder="请选择客户经理" clearable size="small">
          <el-option v-for="dict in customerServiceList"
                     :key="dict.id" :label="dict.nickname" :value="dict.id"/>
        </el-select>
      </el-form-item>
      <el-form-item label="客户状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择客户状态" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.CUSTOMER_STATUS)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item label="部门" prop="department">
        <el-input v-model="queryParams.department" placeholder="请输入部门" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="创建时间">
        <el-date-picker v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:customer:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:customer:export']">导出</el-button>
      </el-col>
       <el-col :span="1.5">
        <el-button type="primary" size="mini" @click="batchHandover"
                   :disabled="multipleSelection.length === 0"
                   >批量移交</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list"    @selection-change="handleSelectionChange">
      <el-table-column
        type="selection"
        width="55">
      </el-table-column>
      <el-table-column label="客户编号" align="center" prop="number" />
      <el-table-column label="客户名称" align="center" prop="name" />
      <el-table-column label="客户等级" align="center" prop="level">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_LEVEL" :value="scope.row.level" />
        </template>
      </el-table-column>
      <el-table-column label="国家" align="center" prop="country">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.COUNTRY" :value="scope.row.country" />
        </template>
      </el-table-column>
      <el-table-column label="客户经理" align="center" prop="customerService" :formatter="customerServiceFn">
      </el-table-column>
      <el-table-column label="客户状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="部门" align="center" prop="department" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-folder-add" @click="distribution(scope.row)">移交</el-button>
          <el-button size="mini" type="text" icon="el-icon-crop" @click="fishingFn(scope.row)">捞取</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!--   移交 -->
    <el-dialog
      center
      title="客服"
      :visible.sync="transferShow"
      width="30%">
      <div style="width: 100%;min-height: 200px;text-align: center">
       <el-select filterable v-model="service">
         <el-option v-for="(item,index) in customerServiceList" :key="index" :label="item.nickname" :value="item.id"></el-option>
       </el-select>
<!--        <el-radio-group v-model="service">-->
<!--          <el-radio style="margin: 5px;" v-for="(item,index) in customerServiceList" :key="index" :label="item.id">{{item.nickname}}</el-radio>-->
<!--        </el-radio-group>-->
      </div>
      <span slot="footer" class="dialog-footer">
    <el-button @click="transferShow = false">取 消</el-button>
    <el-button type="primary" v-if="isBatch" @click="transferFn(multipleSelection.map(item => item.id))">确 定</el-button>
    <el-button type="primary" v-else @click="transferFn([transferData.id])">确 定</el-button>
  </span>
    </el-dialog>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>
  </div>
</template>

<script>
import { createCustomer, updateCustomer, deleteCustomer,handOverCustomer,getPublicList,exportCustomerExcel, setFishing } from "@/api/ecw/customer";
import { getDictDatas, DICT_TYPE } from '@/utils/dict';
import upload from '@/components/ImageUpload'
import {listServiceUser} from "@/api/system/user";
export default {
  name: "customerToBeAssigned",
  components: {
    upload
  },
  data() {
    return {
      getDictDatas,
      DICT_TYPE,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 客户列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      customerServiceList:[],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        number: null,
        name: null,
        level: null,
        source: null,
        customerService: null,
        status: null,
        department: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [{ required: true, message: "客户名称不能为空", trigger: "blur" }],
        country: [{ required: true, message: "国家不能为空", trigger: "blur" }],
        level: [{ required: true, message: "客户等级不能为空", trigger: "blur" }],
        type: [{ required: true, message: "客户类别不能为空", trigger: "blur" }],
        // createTime: [{ required: true, message: "创建时间不能为空", trigger: "blur" }],
        source: [{ required: true, message: "客户来源不能为空", trigger: "blur" }],
        customerService: [{ required: true, message: "客户经理不能为空", trigger: "blur" }],
        status: [{ required: true, message: "客户状态不能为空", trigger: "blur" }],
        founder: [{ required: true, message: "创建人不能为空", trigger: "blur" }],
      },
      // 网点
      nodeList: [],
      showLine: false,
      service:undefined,//客服
      transferData:undefined,//移交数据
      transferShow:false,
      multipleSelection:[],
      isBatch:false,
    };
  },
  created() {
    this.getList();
    listServiceUser().then(r=>{
      console.log(r,'客服');
      this.customerServiceList = r.data;
    })
    // getNodeList().then(r => {
    //   this.nodeList = r.data
    // })
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getPublicList(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        number: undefined,
        name: undefined,
        level: undefined,
        country: undefined,
        type: undefined,
        agentId: undefined,
        company: undefined,
        address: undefined,
        productType: undefined,
        productId: undefined,
        pickupPoint: undefined,
        memberId: undefined,
        birthday: undefined,
        balance: undefined,
        source: undefined,
        picture: undefined,
        customerService: undefined,
        customerContacts: [],
        customerLines: [],
        promoter: undefined,
        status: undefined,
        founder: undefined,
        department: undefined,
        invoiceTitle: undefined,
        licenseNumber: undefined,
        bank: undefined,
        bankNumber: undefined,
        project: undefined,
        billingAddress: undefined,
        billingTell: undefined,
        taxRate: undefined,
        remarks: undefined,
        arrivalConfirm: undefined,
        weightUnit: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$router.push('/customer/add-edit/0')
      // this.reset();
      // this.open = true;
      // this.title = "添加客户";
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.$router.push('/customer/query/' + row.id)
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$router.push('/customer/edit/' + row.id)
      // this.reset();
      // const id = row.id;
      // getCustomer(id).then(response => {
      //   this.form = { ...this.form, ...response.data };
      //   this.open = true;
      //   this.title = "修改客户";
      // });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          // return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateCustomer(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createCustomer(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 移交按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除客户编号为"' + id + '"的数据项?').then(function() {
        return deleteCustomer(id);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有客户数据项?').then(() => {
        this.exportLoading = true;
        return exportCustomerExcel(params);
      }).then(response => {
        this.$download.excel(response, '${table.classComment}.xls');
        this.exportLoading = false;
      }).catch(() => {});
    },
    //分配客服
    distribution(row){
      this.service = row.customerService
      this.transferData = row;
      this.transferShow =true;
      this.isBatch = false;

    },
    customerServiceFn(val){
      if(this.customerServiceList.length > 0){
        let index =this.customerServiceList.findIndex(item => item.id === val.customerService);
        return index !== -1  ? this.customerServiceList[index]?.nickname :''
      }else {
        return ''
      }
    },
    transferFn(val){
      if(!this.service){
        return this.$message.warning('请选择客户经理！');
      }
      handOverCustomer({
        customerServiceId:this.service,
        customerIdList:val
      }).then(r=>{
        if(r.code === 0){
          this.transferShow = false;
          this.service = '';
          this.getList();
          this.multipleSelection = [];
          this.$message.success('移交成功！');
        }
      })
    },
    fishingFn(row){
      this.$confirm(`是否要捞取${row.name}的客户`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        setFishing({id:row.id}).then(r=>{
          if(r.code === 0){
            this.getList()
            this.$message({
              type: 'success',
              message: '捞取成功!'
            });
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消捞取'
        });
      });
    },
    batchHandover(){
      this.transferShow = true;
      this.isBatch = true
    },
    handleSelectionChange(val){
      this.multipleSelection = val;
    }
  }
};
</script>
